<#--
/* Copyright 2009-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 -->
<#assign typeMap = { "примечание": "note", "обоснование": "just","описание": "def","":""}/>
<#macro showref req text islist tp val refines>
	<#if val??>
		<#if (text??&&text?length>0)>
			${text}:<br>
		</#if>
		<#if islist>
			<#list val.getValues() as node>
				<@showref req "" false val.getType() node refines/>
			</#list>
		<#else>
			<#if val.getNodes?? && val.getNodes(req.attrs())??>
				<#local nodes = val.getNodes(req.attrs())/>
				<#list nodes as node>
					<#local fida = 0/>
					<#if node.attrs().getStringAttributeValue("ForeignID")??>
						<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
						<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
							<a href = "${utils.getTemplFileName(node.getTreeDB())}#${fida}">${node.getTreeDB().getResName()?upper_case+fida}</a><br/>
						<#else>
							<a href = "#${fida}">${fida}</a><br/>
						</#if>
					<#else>
						<span class = "error">${refines.valueToString(req.attrs(),tp,val.getRaw())}</span><br/>
					</#if>
	 			</#list>
			<#else>
				<#if val.getRaw??>
	 				<span class = "error">${refines.valueToString(req.attrs(),tp,val.getRaw())}</span><br/>
	 			</#if>
	 		</#if>
	 	</#if>
	</#if>
</#macro>
<#macro showheading req lvl path>
    <#if (coreUtils.isHeader(req))>
        <#local childrenList = req.getSortedShownChildren()/>
    	<#if (lvl>0)>
    		<#local fid = 0/>
    		<#if req.attrs().getStringAttributeValue("ForeignID")??>
    			<#local fid = req.attrs().getStringAttributeValue("ForeignID")/>
    		</#if>
			<li class='toc-level${lvl}'><span class='toc-text'><a href='#${fid}'>${path} ${req.getNameOrId()}</a></span><span class='toc-num'>${fid}</span></li>
		</#if>
		<#local i = 1/>
		<#if (path?length>0)>
			<#local path = path+"."/>
		</#if>
		<#list childrenList as child>
			<@showheading child lvl+1 path+i/>
			<#if coreUtils.isHeader(child)>
				<#local i = i + 1/>
			</#if>
		</#list>
    </#if>
</#macro>
<#macro showreq req lvl path>
	<#local text = ""/>
	<#local isHeader = coreUtils.isHeader(req)/>
	
	<#if (lvl>0)>
		<#if isHeader>
			<#local text = "<b>"+path+" "+req.getNameOrId()+"</b>"/>
		<#else>
			<#if req.getDescription(reportLocation)?has_content>
				<#local cl = 'requirement'/>
				<#local kind=""/>
			    <#local kattr=req.attrs().getStringAttributeValue("Вид","")?lower_case/>
			    <#if !kattr?? || kattr?length==0>
			    	<#if req.getType()=="TextNode">
			    		<#local kattr="описание"/>
			    	</#if>
			    </#if>
				<#if kattr??&&typeMap[kattr]??>
					<#local kind = typeMap[kattr]/>
					<#if kind?? && (kind?length>0)>
						<#local cl = 'textnode-'+kind/>
					</#if>
				</#if>
	            <#local text=req.getDescription("<div class='"+cl+"'>","</div>",reportLocation,
	            										utils.getURIResolver())/>
	        </#if>
	    </#if>
		<#local fid = 0/>
		<#if req.attrs().getStringAttributeValue("ForeignID")??>
			<#local fid = req.attrs().getStringAttributeValue("ForeignID")/>
		</#if>
		<#local tp = "Требование"/>
		<#if coreUtils.isHeader(req)>
			<#local tp = "Заголовок"/>
		<#else>
			<#if req.attrs().getStringAttributeValue("Вид")??>
				<#local tp = req.attrs().getStringAttributeValue("Вид")/>
			</#if>
		</#if>
		<#local pr = ""/>
		<#if (req.attrs().getStringAttributeValue("Производное"))??>
			<#local pr = req.attrs().getStringAttributeValue("Производное")/>
		</#if>
		<tr> <td>${fid}</td>
		<td style="max-width:850px"><a name="${fid}"></a>${text}</td>
		<td>${tp}</td>
		<td>${pr}</td>
		<td>
		<#if req.attrs().getAttribute("refines")??>
			<#local refines = req.attrs().getAttribute("refines")/>
			<@showref req "Уточняет" refines.isList() refines.getType() refines.getValue() refines/>
		</#if>
		<#if utils.getRevertNodes(req, "refines")??>
			Уточняется в:<br>
			<#local nodes = utils.getRevertNodes(req, "refines")/>
			<#list nodes as node>
				<#local fida = 0/>
				<#if node.attrs().getStringAttributeValue("ForeignID")??>
					<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
					<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
						<a href = "${utils.getTemplFileName(node.getTreeDB())}#${fida}">${node.getTreeDB().getResName()?upper_case+fida}</a><br/>
					<#else>
						<a href = "#${fida}">${fida}</a><br/>
					</#if>
				</#if>
 			</#list>
		</#if>
		<#if req.attrs().getAttribute("rationale-ref")??>
			<#local refines = req.attrs().getAttribute("rationale-ref")/>
			<@showref req "Обоснование" refines.isList() refines.getType() refines.getValue() refines/>
		</#if>
		<#if utils.getRevertNodes(req, "rationale-ref")??>
			Обосновывает:<br>
			<#local nodes = utils.getRevertNodes(req, "rationale-ref")/>
			<#list nodes as node>
				<#local fida = 0/>
				<#if node.attrs().getStringAttributeValue("ForeignID")??>
					<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
					<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
						<a href = "${utils.getTemplFileName(node.getTreeDB())}#${fida}">${node.getTreeDB().getResName()?upper_case+fida}</a><br/>
					<#else>
						<a href = "#${fida}">${fida}</a><br/>
					</#if>
				</#if>
 			</#list>
		</#if>
		<#if (utils.getDirectTerms(req)??)>
		 	<#local terms = utils.getDirectTerms(req)/>
		 	<#if (terms?is_enumerable && terms?size>0)>
		 		Термины:<br/>
			 	<#list terms as term>
	 				<#local nodes = utils.getDirectNodes(req, term)/>
		 			<#list nodes as node>
		 				<#if (node.attrs().getStringAttributeValue("ForeignID")??)>
							<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
							<#if (fida??&&fida?length>0)>
								<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
									<a href = "${utils.getTemplFileName(node.getTreeDB())}#${fida}">${term}</a><br/>
								<#else>
									<a href = "#${fida}">${term}</a><br/>
								</#if>
								
							</#if>
						</#if>
		 			</#list>
			 	</#list>
			 </#if>
		 </#if>
		 <#if (utils.getRevertTerms(req)?? && (utils.getRevertTerms(req)?size>0))>
	 		<#local termsrevn = utils.getRevertTerms(req)/>
	 	Использование:
	 		<#local last = ""/>
	 		<#list termsrevn as term>
	 			<#if utils.getRevertTerms(req, term)??>
		 			<#local nodes = utils.getRevertTerms(req, term)/>
					<#local out = ""/>
					<#list nodes as node>
						<#local fida = 0/>
						<#if node.attrs().getStringAttributeValue("ForeignID")??>
							<#local pre = term/>
							<#if last==pre>
								<#local out = out + ", "/>
							<#else>
						 		<#local last = pre/>
						 		<#local cnt = 0/>
						 		<#local first = true/>
								<#local out = out + '<br/> '+last+':<br/> '/>
							</#if>
							<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
							<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
								<#local out = out +'<a href = "'+utils.getTemplFileName(node.getTreeDB())+'#'+fida+'">'+node.getTreeDB().getResName()?upper_case+fida+'</a>'/>
							<#else>
								<#local out = out +'<a href = "#'+fida+'">'+fida+'</a>'/>
							</#if>
						</#if>
					</#list>
					${out}
				</#if>
	 		</#list>
	 	</#if>
		<#if utils.getRevertNodes(req, "next-ref")??>
			Ранее:<br>
			<#local nodes = utils.getRevertNodes(req, "next-ref")/>
			<#list nodes as node>
				<#local fida = 0/>
				<#if node.attrs().getStringAttributeValue("ForeignID")??>
					<#local fida = node.attrs().getStringAttributeValue("ForeignID")/>
					<#if node.getTreeDB().getResName()!=req.getTreeDB().getResName()>
						<a href = "${utils.getTemplFileName(node.getTreeDB())}#${fida}">${node.getTreeDB().getResName()?upper_case+fida}</a><br/>
					<#else>
						<a href = "#${fida}">${fida}</a><br/>
					</#if>
				</#if>
 			</#list>
		</#if>
		<#if req.attrs().getAttribute("next-ref")??>
			<#local refines = req.attrs().getAttribute("next-ref")/>
			<@showref req "Далее" refines.isList()  refines.getType() refines.getValue() refines/>
		</#if>
		</td>
		</tr>
    </#if>
    <#if isHeader>
        <#local childrenList = req.getSortedShownChildren()/>
		<#if (path?length>0)>
			<#local path = path+"."/>
		</#if>
		<#local i = 1/>
		<#list childrenList as child>
			<@showreq child lvl+1 path+i/>
			<#if coreUtils.isHeader(child)>
				<#local i = i + 1/>
			</#if>
		</#list>
	</#if>
</#macro>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
  <title></title>
  <style type="text/css">
    p { margin: 1mm }
    h3 { font-family: sans-serif }
    table, th, td { border: 1px solid black; }
    table { border-collapse: collapse; margin-top: 5mm }
    .meta          { background: #fafafa }
    .attribute     { background: #eff6ff }
    .textnode      { background: #ccffcc }
    .textnode-def  { background: #ccffcc }
    .textnode-note { background: #c9ffff }
    .textnode-just { background: #daebdc }
    .requirement   { background: #ffefff }
    .error         { background: #ff0000 }

    /* Table of contents */
    ul.toc {
      list-style: none;
      margin: 0;
      padding: 0;
    }
    .toc a {
      text-decoration: none;
    }
    .toc-level1 span.toc-text {
      font-weight: bold;
      font-size: 110%
    }
    .toc-level2 span.toc-text {
      padding-left:4mm;
      font-size: 100%
    }
    .toc-level3 span.toc-text {
      padding-left:8mm;
      font-size: 95%
    }
    .toc-level4 span.toc-text {
      padding-left:12mm;
      font-size: 90%
    }
    .toc-level5 span.toc-text {
      padding-left:16mm;
      font-size: 88%
    }
    .toc-level6 span.toc-text {
      padding-left:20mm;
      font-size: 86%
    }
    .toc-level7 span.toc-text {
      padding-left:24mm;
      font-size: 84%
    }
    .toc-num {
      float:right;
      padding-left:5px;
      visibility: hidden;
    }

    /* Popup container */
    .popup {
      position: relative;
      display: inline-block;
      cursor: pointer;
    }

    /* The actual popup (appears on top) */
    .popup .popuptext {
      visibility: hidden;
      max-width: 700px;
      min-width: 400px;
      border-radius: 5px;
      position: absolute;
      z-index: 1;
      bottom: 125%;
      right: 100%;
      margin-right: -50px;
      background-color: #e0e0e0;
      border-color: #e0e0e0;
      border: 1px dotted black;
    }

    /* Popup arrow */
    .popup .popuptext::after {
      content: "";
      position: absolute;
      top: 100%;
      right: 100%;
      /*margin-left: -2px;*/
    }

    /* Toggle this class when clicking on the popup container (hide and show the popup) */
    .popup .show {
      visibility: visible;
      animation: fadeIn 1s
    }

    /* Add animation (fade in the popup) */
    @keyframes fadeIn {
      from {opacity: 0;}
      to {opacity:1 ;}
    }
  </style>
  <script>
    function popupdef(id) {
      var popup = document.getElementById(id);
      popup.classList.toggle("show");
    }
  </script>
</head>
<body lang="ru-RU" dir="ltr">
<div>
<ul class='toc'>
<@showheading rootReq 0 ""/>
</ul>
</div>
<hr>
<table><tbody><tr class="theader">
<th>ID</th> <th style="max-width:850px">Текст</th> <th>Тип объекта</th> <th>Пр.</th> <th>Ссылки</th>
</tr>
<@showreq rootReq 0 ""/>
</tbody></table>
</body>
</html>